import sys
import bonobo
from optparse import OptionParser

def main():
    parser = OptionParser(usage="usage: %prog [options] [message]")
    parser.add_option("-f", "--full",
                      help="Message is in full format specification",
                      action="store_true", dest="full", default=False)
    parser.add_option("-s", "--stdin",
                      help="Read message from stdin;  Implies --full",
                      action="store_true", dest="stdin", default=False)
    (options, args) = parser.parse_args()
    timeout = -1
    if len(args) == 2:
        print >> sys.stderr, "Warning: timeout argument is deprecated and will be removed in the future"
        timeout = int(args[1])
    if not options.stdin and not (1 <= len(args) <= 2):
        parser.error("wrong number of arguments")
    
    osd = bonobo.get_object("OAFIID:GNOME_OSD", "IDL:Bonobo/Application:1.0")
    osd.ref() # AppClient steals one reference
    osd = bonobo.AppClient(osd)

    if options.stdin:
        msg = sys.stdin.read()
    else:
        msg = args[0]
    if options.full or options.stdin:
        error = osd.msg_send("show-full", [msg])
    else:
        error = osd.msg_send("show", [msg, timeout])
    if error:
        print >> sys.stderr, "Error: %s" % error
        raise SystemExit, 2

